<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/lex_error_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/13/84  lex_error_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>Entry points in lex_error_:
<span id="L5" class="LineNr">  5 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>:Entry: lex_error_: 02/13/84  lex_error_
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Function: generates compiler-style error messages on the error_output
<span id="L11" class="LineNr"> 11 </span>I/O switch for translators generated by the reduction_compiler command
<span id="L12" class="LineNr"> 12 </span>and for other procedures that process tokens generated by the
<span id="L13" class="LineNr"> 13 </span>lex_string_ subroutine.  See &quot;Notes&quot; below for a description of the
<span id="L14" class="LineNr"> 14 </span>error message format.
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>Syntax:
<span id="L18" class="LineNr"> 18 </span>declare lex_error_ entry options <span class="textRainbow_lv0_p0">(</span>variable<span class="textRainbow_lv0_p0">)</span>;
<span id="L19" class="LineNr"> 19 </span>call lex_error_ <span class="textRainbow_lv0_p0">(</span>error_number<span class="textRainbow_lv0_o0">,</span> Serror_printed<span class="textRainbow_lv0_o0">,</span> severity_no<span class="textRainbow_lv0_o0">,</span>
<span id="L20" class="LineNr"> 20 </span>     max_severity_no<span class="textRainbow_lv0_o0">,</span> Pstmt<span class="textRainbow_lv0_o0">,</span> Ptoken<span class="textRainbow_lv0_o0">,</span> Scontrol<span class="textRainbow_lv0_o0">,</span> message<span class="textRainbow_lv0_o0">,</span> brief_message<span class="textRainbow_lv0_o0">,</span>
<span id="L21" class="LineNr"> 21 </span>     arg1<span class="textRainbow_lv0_o0">,</span> ...<span class="textRainbow_lv0_o0">,</span> argN<span class="textRainbow_lv0_p0">)</span>;
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>Arguments:
<span id="L25" class="LineNr"> 25 </span>error_number
<span id="L26" class="LineNr"> 26 </span>   is the error number <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>, as it should appear in the error
<span id="L27" class="LineNr"> 27 </span>   message.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L28" class="LineNr"> 28 </span>Serror_printed
<span id="L29" class="LineNr"> 29 </span>   is a switch <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> unaligned<span class="textRainbow_lv0_p0">)</span> that is &quot;1&quot;b if the text of the error
<span id="L30" class="LineNr"> 30 </span>   message has been printed in a previous error and &quot;0&quot;b, otherwise.
<span id="L31" class="LineNr"> 31 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>.  If Serror_printed is &quot;1&quot;b, the text is omitted from
<span id="L32" class="LineNr"> 32 </span>   the error message.  Otherwise, text is included and the switch is
<span id="L33" class="LineNr"> 33 </span>   set to &quot;1&quot;b to suppress this text in any subsequent occurrence of
<span id="L34" class="LineNr"> 34 </span>   the same error.
<span id="L35" class="LineNr"> 35 </span>severity_no
<span id="L36" class="LineNr"> 36 </span>   is the severity number <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span> of the error.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  It must
<span id="L37" class="LineNr"> 37 </span>   have a value from 0 through 4.  See &quot;Notes&quot; below for an
<span id="L38" class="LineNr"> 38 </span>   interpretation of the severity_no value.
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>max_severity_no
<span id="L42" class="LineNr"> 42 </span>   is the severity number <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span> of the highest severity error
<span id="L43" class="LineNr"> 43 </span>   message that has been printed by the lex_error_ subroutine.
<span id="L44" class="LineNr"> 44 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>.  Before the lex_error_ is invoked by a translator,
<span id="L45" class="LineNr"> 45 </span>   max_severity_no should be initialized to 0.  Each time it is called,
<span id="L46" class="LineNr"> 46 </span>   the lex_error_ subroutine compares this value with the severity_no
<span id="L47" class="LineNr"> 47 </span>   of the current message and sets max_severity_no to the higher of
<span id="L48" class="LineNr"> 48 </span>   these two numbers.
<span id="L49" class="LineNr"> 49 </span>Pstmt
<span id="L50" class="LineNr"> 50 </span>   is a pointer to the statement descriptor generated by the
<span id="L51" class="LineNr"> 51 </span>   lex_string_ subroutine for the statement that is to be printed after
<span id="L52" class="LineNr"> 52 </span>   the error message.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  The line number and statement number
<span id="L53" class="LineNr"> 53 </span>   given in this statement descriptor are included in the error
<span id="L54" class="LineNr"> 54 </span>   message.
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>Ptoken
<span id="L58" class="LineNr"> 58 </span>   is a pointer to the token descriptor of the token that is in error.
<span id="L59" class="LineNr"> 59 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  If Pstmt is null, then the number of the line that
<span id="L60" class="LineNr"> 60 </span>   contains the token described by the descriptor is included in the
<span id="L61" class="LineNr"> 61 </span>   error message.  If both Pstmt and Ptoken are null, then no line
<span id="L62" class="LineNr"> 62 </span>   number is included in the error message.
<span id="L63" class="LineNr"> 63 </span>Scontrol
<span id="L64" class="LineNr"> 64 </span>   is a control bit string <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span> that determines whether the message
<span id="L65" class="LineNr"> 65 </span>   character string or the brief_message character string is used in
<span id="L66" class="LineNr"> 66 </span>   the error message.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  The interpretation of the bits in this
<span id="L67" class="LineNr"> 67 </span>   string is described in &quot;Notes&quot; below.
<span id="L68" class="LineNr"> 68 </span>
<span id="L69" class="LineNr"> 69 </span>
<span id="L70" class="LineNr"> 70 </span>error_message_text
<span id="L71" class="LineNr"> 71 </span>   is an ioa_ control string <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> or char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_p0">)</span> that contains
<span id="L72" class="LineNr"> 72 </span>   the long form of the error message text.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L73" class="LineNr"> 73 </span>brief_message_text
<span id="L74" class="LineNr"> 74 </span>   is an ioa_ control string <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> or char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_p0">)</span> that contains
<span id="L75" class="LineNr"> 75 </span>   the brief form of the error message text.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L76" class="LineNr"> 76 </span>argN
<span id="L77" class="LineNr"> 77 </span>   are optional arguments that are substituted into the ioa_ message
<span id="L78" class="LineNr"> 78 </span>   texts, in place of the ioa_ control characters.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>Notes: The error messages that are generated by the lex_error_
<span id="L82" class="LineNr"> 82 </span>subroutine have the form shown below.
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>   prefix error_number, SEVERITY severity_no IN STATEMENT k OF LINE l.
<span id="L85" class="LineNr"> 85 </span>   error_message_text
<span id="L86" class="LineNr"> 86 </span>   SOURCE:
<span id="L87" class="LineNr"> 87 </span>   statement_in_error
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>For example,
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>   ERROR 7, SEVERITY 2 IN STATEMENT 2 OF LINE 2.
<span id="L92" class="LineNr"> 92 </span>   A bad track specification was given in a Volume statement.
<span id="L93" class="LineNr"> 93 </span>   9track has been assumed.
<span id="L94" class="LineNr"> 94 </span>   SOURCE:
<span id="L95" class="LineNr"> 95 </span>   Volume: 70082, 8track;
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>The severity_no associated with an error controls the prefix that is
<span id="L99" class="LineNr"> 99 </span>placed in the error message, as shown in the list below.
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>0   COMMENT
<span id="L102" class="LineNr">102 </span>   Comment.  The error message is a comment, which does not indicate
<span id="L103" class="LineNr">103 </span>   that an error has occurred, but merely provides information for the
<span id="L104" class="LineNr">104 </span>   user.
<span id="L105" class="LineNr">105 </span>1   WARNING
<span id="L106" class="LineNr">106 </span>   Warning only.  The error message warns of a statement that may or
<span id="L107" class="LineNr">107 </span>   may not be in error, but compilation continues without ill effect.
<span id="L108" class="LineNr">108 </span>2   ERROR
<span id="L109" class="LineNr">109 </span>   Correctable error.  The message diagnoses an error that the
<span id="L110" class="LineNr">110 </span>   translator can correct, probably without ill effect.  Compilation
<span id="L111" class="LineNr">111 </span>   continues, but correct results cannot be guaranteed.
<span id="L112" class="LineNr">112 </span>
<span id="L113" class="LineNr">113 </span>
<span id="L114" class="LineNr">114 </span>3   FATAL ERROR
<span id="L115" class="LineNr">115 </span>   An uncorrectable but recoverable error.  The translator has detected
<span id="L116" class="LineNr">116 </span>   an error that it cannot correct.  Translation continues in an
<span id="L117" class="LineNr">117 </span>   attempt to diagnose further errors, but no output is produced by the
<span id="L118" class="LineNr">118 </span>   translation.
<span id="L119" class="LineNr">119 </span>4   TRANSLATOR ERROR
<span id="L120" class="LineNr">120 </span>   An unrecoverable error.  The translator cannot continue beyond this
<span id="L121" class="LineNr">121 </span>   error.  The translation is aborted after the error message is
<span id="L122" class="LineNr">122 </span>   printed.
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>The phrase &quot;IN STATEMENT k OF LINE l&quot; appears in the error message only
<span id="L126" class="LineNr">126 </span>if Pstmt is a nonnull pointer.  Pstmt is assumed to point to a
<span id="L127" class="LineNr">127 </span>statement descriptor generated by the lex_string_ subroutine.  The
<span id="L128" class="LineNr">128 </span>values for k and l come from this descriptor.  If the error occurred in
<span id="L129" class="LineNr">129 </span>the first statement of line l, then the phrase &quot;STATEMENT k OF&quot; is
<span id="L130" class="LineNr">130 </span>omitted from the error message.
<span id="L131" class="LineNr">131 </span>
<span id="L132" class="LineNr">132 </span>If Pstmt is null, then &quot;STATEMENT k OF&quot; is omitted from the error
<span id="L133" class="LineNr">133 </span>message, and l is the line number on which the token described by
<span id="L134" class="LineNr">134 </span>Ptoken appears.  If Ptoken is a null pointer, &quot;IN STATEMENT k OF LINE
<span id="L135" class="LineNr">135 </span>l&quot; is omitted altogether.
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>
<span id="L138" class="LineNr">138 </span>Currently, only the first two bits of the Scontrol bit string have
<span id="L139" class="LineNr">139 </span>meaning, as shown in the table below.
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>&quot;00&quot;b     The printed error contains the error_message_text the first
<span id="L142" class="LineNr">142 </span>          time the error occurs, and the brief_message_text for
<span id="L143" class="LineNr">143 </span>          subsequent occurrences of that error during a given
<span id="L144" class="LineNr">144 </span>          translation.
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>&quot;10&quot;b     The printed error always contains the error_message_text.
<span id="L147" class="LineNr">147 </span>
<span id="L148" class="LineNr">148 </span>&quot;11&quot;b     The printed error always contains the error_message_text.
<span id="L149" class="LineNr">149 </span>
<span id="L150" class="LineNr">150 </span>&quot;01&quot;b     The printed error always contains the brief_message_text.
<span id="L151" class="LineNr">151 </span>
<span id="L152" class="LineNr">152 </span>
<span id="L153" class="LineNr">153 </span>If Serror_printed is &quot;1&quot;b, then the lex_error_ subroutine assumes the
<span id="L154" class="LineNr">154 </span>text of the error message has already been printed in a previous
<span id="L155" class="LineNr">155 </span>message.  It uses the long or brief error message text, according to
<span id="L156" class="LineNr">156 </span>the value of Scontrol.
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>If Pstmt points to a statement descriptor, then the lex_error_
<span id="L159" class="LineNr">159 </span>subroutine sets the error_in_stmt switch in the statement descriptor.
<span id="L160" class="LineNr">160 </span>It also checks the value of the output_in_err_msg switch in the
<span id="L161" class="LineNr">161 </span>descriptor.  If this switch is &quot;0&quot;b, the lex_error_ subroutine sets it
<span id="L162" class="LineNr">162 </span>to &quot;1&quot;b and prints the character string representation of the statement
<span id="L163" class="LineNr">163 </span>in the error message.  If it is already &quot;1&quot;b, then the lex_error_
<span id="L164" class="LineNr">164 </span>subroutine assumes that the statement has already appeared in another
<span id="L165" class="LineNr">165 </span>error message and omits the &quot;SOURCE:&quot; phrase from the error message.
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>
<span id="L168" class="LineNr">168 </span>If max_severity_no is less than severity_no, then the lex_error_
<span id="L169" class="LineNr">169 </span>subroutine sets max_severity_no equal to severity_no.
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>Refer to the lex_string_ subroutine for a description of statement and
<span id="L172" class="LineNr">172 </span>token descriptors.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
